import java.util.Vector;

public class GraphDriver {
	
	private static Vector<Vertex> vectorOfVertices;
	private static Vertex[] arrayOfVertices;
	
	private static void extractArrayOfVertices() {
		arrayOfVertices = new Vertex[vectorOfVertices.size()];
		
		for ( int i = 0 ; i < vectorOfVertices.size() ; i++ ) {
			arrayOfVertices[i] = vectorOfVertices.get(i);
		}
	}
	
	private static Graph createGraph1() {
		
		vectorOfVertices = new Vector<Vertex>();
				
		Vertex a = new Vertex("A");
		vectorOfVertices.add(a);
		Vertex b = new Vertex("B");
		vectorOfVertices.add(b);
		Vertex c = new Vertex("C");
		vectorOfVertices.add(c);
		Vertex d = new Vertex("D");
		vectorOfVertices.add(d);
		Vertex e = new Vertex("E");
		vectorOfVertices.add(e);
		Vertex f = new Vertex("F");
		vectorOfVertices.add(f);
		Vertex g = new Vertex("G");		
		vectorOfVertices.add(g);
		
		// A
		Edge e1 = new Edge(a, b, 1);
		Edge e2 = new Edge(a, d, 1);
		Edge e3;
		Edge e4;
		
		Edge[] edgesForA = {e1, e2};
		a.addEdges(edgesForA);
		
		// B
		e1 = new Edge(b, a, 1);
		e2 = new Edge(b, c, 1);
		e3 = new Edge(b, d, 1);
		e4 = new Edge(b, e, 1);
		
		Edge[] edgesForB = {e1, e2, e3, e4};
		b.addEdges(edgesForB);
		
		// C
		e1 = new Edge(c, b, 1);
		e2 = new Edge(c, e, 1);

		Edge[] edgesForC = {e1, e2};
		c.addEdges(edgesForC);
		
		// D
		e1 = new Edge(d, a, 1);
		e2 = new Edge(d, b, 1);
		e3 = new Edge(d, f, 1);
		
		Edge[] edgesForD = {e1, e2, e3};
		d.addEdges(edgesForD);
		
		// E
		e1 = new Edge(e, b, 1);
		e2 = new Edge(e, c, 1);
		e3 = new Edge(e, f, 1);
		
		Edge[] edgesForE = {e1, e2, e3};
		e.addEdges(edgesForE);
		
		// F
		e1 = new Edge(f, d, 1);
		e2 = new Edge(f, e, 1);
		
		Edge[] edgesForF = {e1, e2};
		f.addEdges(edgesForF);

		extractArrayOfVertices();
		Graph graph = new Graph();
		graph.addVertices(arrayOfVertices);
		
		return graph;
	}

	private static Graph createGraph2() {
		
		vectorOfVertices = new Vector<Vertex>();
				
		Vertex a = new Vertex("A");
		vectorOfVertices.add(a);
		Vertex b = new Vertex("B");
		vectorOfVertices.add(b);
		Vertex c = new Vertex("C");
		vectorOfVertices.add(c);
		Vertex d = new Vertex("D");
		vectorOfVertices.add(d);
		Vertex e = new Vertex("E");
		vectorOfVertices.add(e);
		Vertex f = new Vertex("F");
		vectorOfVertices.add(f);
		Vertex g = new Vertex("G");		
		vectorOfVertices.add(g);
		Vertex h = new Vertex("H");		
		vectorOfVertices.add(h);
		Vertex i = new Vertex("I");		
		vectorOfVertices.add(i);

		// A
		Edge e1 = new Edge(a, b, 1);
		Edge e2;
		Edge e3;
		a.addEdge(e1);
		
		// B
		e1 = new Edge(b, c, 1);
		b.addEdge(e1);
		
		// C
		e1 = new Edge(c, i, 1);
		c.addEdge(e1);
		
		// D
		e1 = new Edge(d, b, 1);
		e2 = new Edge(d, e, 1);
		e3 = new Edge(d, g, 1);
		
		Edge[] edgesForD = {e1, e2, e3};
		d.addEdges(edgesForD);
		
		// E
		e1 = new Edge(e, f, 1);
		e.addEdge(e1);
		
		// F
		e1 = new Edge(f, g, 1);
		f.addEdge(e1);
		
		// G
		e1 = new Edge(g, h, 1);
		g.addEdge(e1);

		// H
		e1 = new Edge(h, d, 1);
		h.addEdge(e1);

		// I
		e1 = new Edge(i, d, 1);
		i.addEdge(e1);

		extractArrayOfVertices();
		
		Graph graph = new Graph();
		graph.addVertices(arrayOfVertices);
		
		return graph;
	}

	private static Graph createGraph3() {
		
		vectorOfVertices = new Vector<Vertex>();
				
		Vertex a = new Vertex("A");
		vectorOfVertices.add(a);
		Vertex b = new Vertex("B");
		vectorOfVertices.add(b);
		Vertex c = new Vertex("C");
		vectorOfVertices.add(c);
		Vertex d = new Vertex("D");
		vectorOfVertices.add(d);
		
		// A
		Edge e1 = new Edge(a, b, 3);
		Edge e2 = new Edge(a, c, 7);
		Edge e3;
		Edge e4;
		
		Edge[] edgesForA = {e1, e2};
		a.addEdges(edgesForA);
		
		// B
		e1 = new Edge(b, d, 1);
		e2 = new Edge(b, c, 5);

		Edge[] edgesForB = {e1, e2};
		b.addEdges(edgesForB);
		
		// C
		e1 = new Edge(c, d, 9);
		
		c.addEdge(e1);
		
		// D
		e1 = new Edge(d, c, 2);
		
		d.addEdge(e1);

		extractArrayOfVertices();
		Graph graph = new Graph();
		graph.addVertices(arrayOfVertices);
		
		return graph;
	}
	
	private static void doBreadthFirstSearch(Graph graph, Vertex startVertex) {
		System.out.println("\nBreadth First Search");
		graph.breadhFirstSearch(startVertex);
		System.out.println(graph);
	}
	
	private static void doDepthFirstSearch(Graph graph, Vertex startVertex) {
		System.out.println("\nDepth First Search");
		graph.depthFirstSearch(startVertex);
		System.out.println(graph);
	}

	private static void doDyjkstraShortestPath(Graph graph, Vertex startVertex) {
		System.out.println("Dyjkstra\'s Shortest Path");
		graph.DyjkstraShortestPaTh(startVertex);
		System.out.println(graph);
	}
	
	public static void main(String[] args) {

		
		// undirected un-weighted graph
		Graph graph = createGraph1();		
		
		System.out.println("\n\nNew Graph 1");
		System.out.println(graph);
		
		doBreadthFirstSearch(graph, arrayOfVertices[0]);
		doDepthFirstSearch(graph, arrayOfVertices[0]);

		

		// directed un-weighted graph
		graph = createGraph2();		
		
		System.out.println("\n\nNew Graph 2");
		System.out.println(graph);
		
		doBreadthFirstSearch(graph, arrayOfVertices[0]);
		doDepthFirstSearch(graph, arrayOfVertices[0]);

		
		
		// directed weighted graph
		graph = createGraph3();		
		
		System.out.println("\n\nNew Graph 3");
		System.out.println(graph);
		
		doBreadthFirstSearch(graph, arrayOfVertices[0]);
		doDepthFirstSearch(graph, arrayOfVertices[0]);
		doDyjkstraShortestPath(graph, arrayOfVertices[0]);
	}
}
